/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

var SERVICE_URL = 'http://pacentltd.com/EduConnectProxy/index.php';
var SCHOOLS_URL = 'http://pacentltd.com/EduConnectProxy/schools.php';


var recipientList = new Array();
var cachedRecipientList = new Array();
var inboxList = new Array();
var cachedInboxList = new Array();
var sentBoxList = new Array();

var recipientID = null;
var recipientName = null;

var messageID = null;
var messageIndex = null;
var replyThreadID = null;

var TYPE_MESSAGE = 0;
var TYPE_NOTIFICATION = 1;

//FLAG TO CHECK IF YOU ARE CURRENTLY ON THE INBOX OR SENTBOX PAGE
var messageListPage = '';

var isFetchingMessage = false;

var isMobile = {
    Android: function() {
        return navigator.userAgent.match(/Android/i);
    },
    BlackBerry: function() {
        return navigator.userAgent.match(/BlackBerry/i);
    },
    iOS: function() {
        return navigator.userAgent.match(/iPhone|iPad|iPod/i);
    },
    Opera: function() {
        return navigator.userAgent.match(/Opera Mini/i);
    },
    Windows: function() {
        return navigator.userAgent.match(/IEMobile/i);
    },
    any: function() {
        return (isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows());
    },
    
    getOs: function(){
        if(isMobile.Android()){
            return 'android';
        }
        
        else if(isMobile.iOS()){
            return 'ios';
        }
        else if(isMobile.BlackBerry()){
            return 'bb';
        }
        else if(isMobile.Windows()){
            return 'windows';
        }
        else{
            return 'other';
        }
        
    }
};

var failedMessages = new Array();
var studentID = null;
var selectTeacherHeaderText = null;

var devicePlatform = isMobile.getOs();
var globalUserID;
var app = {
    register: function() {
        //alert('register function called');
        var pushNotification = window.plugins.pushNotification;
        //pushNotification.register(app.successHandler, app.errorHandler, {"senderID": "1098240987048", "ecb": "app.onNotificationGCM"});
        pushNotification.register(app.successHandler, app.errorHandler, {"senderID": "951911079669", "ecb": "app.onNotificationGCM"}); //Pacent Tech Push API Sender ID
    },
    // result contains any message sent from the plugin call
    successHandler: function(result) {
        // alert('Callback Success! Result = ' + result);
        //alert('successfully registered');

    },
    errorHandler: function(error) {
        //alert(error);
    },
    onNotificationGCM: function(e) {
        switch (e.event)
        {
            case 'registered':
                if (e.regid.length > 0)
                {
                    //console.log("Regid " + e.regid);
                    //alert('registration id = ' + e.regid);
                    regid = e.regid;
                    localStorage.setItem('regID' , regid);
                    //userID = localStorage.getItem('userID');
                    userID = globalUserID;
					schoolId = localStorage.getItem('schoolId');
					//alert('school id: ' + schoolId);
                    $.ajax({
                        url: SERVICE_URL,
                        type: "POST",
                        data: {action: 'getRegistration', regId: regid, userId: userID, schoolId:schoolId, devicePlatform: devicePlatform},
                        crossDomain: true,
                        dataType: 'json',
                        success: function(data) {
                            //alert(data);
                            //alert('successfully sent reg id to server');

                        },
                        error: function(err, textStatus, jqXHR) {
                             //alert('error sending reg id');
                            // alert(JSON.stringify(err));
                            // alert(textStatus);
                        }
                    });
                }
                break;

            case 'message':
                // this is the actual push notification. its format depends on the data model from the push server
                // alert('message = ' + e.message + ' msgcnt = ' + e.msgcnt);
                //push = true;
                //alert(push);

                // if this flag is set, this notification happened while we were in the foreground.
                // you might want to play a sound to get the user's attention, throw up a dialog, etc.
                if (e.foreground)
                {
                   // alert('New Message Received');
                   // navigator.notification.alert("New Message Received", function() {
                   // }, 'Incoming Message', 'OK');
                }
                else
                {  //app was relaunched from the notification bar because it was closed.
                    if (e.coldstart)
                    {

                        //alert('coldstarted from push');
                        getInboxMessageList();
                        populateInboxMessageList();
                        $.mobile.changePage("#inbox-page", {
                            transition: "slide",
                            reverse: false,
                            changeHash: true
                        });

                    }
                    //app was relaunched from the notification bar because it was in a background state.
                    else
                    {
                        //alert('launched from background from push');
                        getInboxMessageList();
                        populateInboxMessageList();
                        $.mobile.changePage("#inbox-page", {
                            transition: "slide",
                            reverse: false,
                            changeHash: true
                        });
                    }
                }


                break;

            case 'error':
                 //alert('GCM error = ' + e.msg);
                break;

            default:
               // alert('An unknown GCM event has occurred');
                break;
        }
    }
};
document.addEventListener("deviceready", onDeviceReady);
function onDeviceReady() {
    navigator.splashscreen.hide();
    goHome();
}


$(document).on('pagebeforeshow' , '#login-page' , function(){
    
    if(localStorage.getItem('userID') != undefined){
        //A user is logged in  
        $.mobile.changePage( "#inbox-page", {
            transition: "slidedown",
            reverse: false,
            changeHash: true
        });
    }


});

$(document).bind('pageshow' , '#login-page' , function(){
    getSchoolsList();
});

$(document).bind('pageinit' , '#login-page' , function(){
    //alert('init');
    
    
    $("#login-btn").click( function(){
       // alert('click');
        username = $("#username").val();
        password = $("#password").val();
        schoolId = $("#select_school").val();
        
        //alert(school);
        
        if(schoolId == 'select'){
           // alert('School Not Selected!');
			navigator.notification.alert("Please select your ward's school and Log in", function() {
                    }, 'No School Selected', 'OK');
            return;
        }

       
        
         if(username === ''){
            $("#username").focus();
        }
        
        else if(password === ''){
            $("#password").focus();
        }

        
        else{
            //alert(username+password);
             $("#login-error").text('');
             $("#ajax-loader-div").show();
             $("#connecting").text('Connecting...');
             $("#login-btn").attr("disabled", true);
            $.ajax({
                url: SERVICE_URL,
                type: "POST",
                data: {action: 'login', username: username, password: password, schoolId:schoolId},
                dataType: 'json',
                timeout: 300000, //5 minutes
                crossDomain: true,
                success: function(json) {
                    
                    //alert('success');
                    //alert(json);

                    if (json.user != null) {

                        //alert("User not null");



                        if (json.user.length > 0) {

                            //alert("greater than zer0");

                            $.each(json.user, function() {

                                userID = this['user_id'];
                                parentID = this['parent_id'];
                                status = this['status'];
                                fullname = this['fullname'];


                            });

                            //alert(fullname);
                            
                            if(status == 1){
                               //alert(fullname);
                                if (window["localStorage"]) { //Check if LocalStorage is supported by the browser

                                    localStorage.setItem('userID' , userID);
                                    localStorage.setItem('parentID' , parentID);
                                    localStorage.setItem('status' , status);
                                    localStorage.setItem('fullname' , fullname);
                                    localStorage.setItem('schoolId' , schoolId);
									
                                    globalUserID = userID;
                                    app.register();
                                    
                                    $.mobile.changePage( "#inbox-page", {
                                        transition: "slide",
                                        reverse: false,
                                        changeHash: true
                                    });

                                } 
                            }
                            else{
                                $("#login-error").text('Incorrect Username or Password!');
                            }


                        }

                    }
                    else {
                       // alert('user is null');
                    }
                    

                },
                error: function(x, t, m) {
                   
                    if (t === "timeout") {
                        navigator.notification.alert("Request timed out. Please try again.", function() {
                            }, 'Connection Timeout', 'Dismiss');
                        
                        //alert("Request timed out. Please try again.");
                    } else {
                        //alert("Unable to connect to the server");
                        navigator.notification.alert("Unable to connect to the server. Please try again.", function() {
                            }, 'Connection Error', 'Dismiss');
                    }
                },
                
                complete: function(){
                    $("#ajax-loader-div").hide();
                    $("#connecting").text('');
                    $("#login-btn").removeAttr("disabled");
                }
                
                
            });
        }
    });
});

$(document).delegate("#inbox-page", "pageinit", function(event) {
    $(".iscroll-wrapper", this).bind( {
    "iscroll_onpulldown" : inboxPagePullDown
    });
});

$(document).on('pageshow' , '#new-message-page' , function(){
    $("#recipient_name_field").val('To: ' + recipientName);
    
    $("#send-new-msg-btn").click( function(){
        if(recipientID != null){
            messageType = undefined;
            senderID = localStorage.getItem('userID');
            receiverID = recipientID;
            subject = $.trim($("#subject_field").val());
            message = $.trim($("#new-message-area").val());

            if ($("#type-msg").is(':checked')) {
                //alert('message checked');
                messageType = TYPE_MESSAGE;

            }
            if ($("#type-notif").is(':checked')) {
                //alert('notifcation checked');
                messageType = TYPE_NOTIFICATION;

            }

            if (subject == '') {
                $("#subject_field").focus();
            }

            else if (message == '') {
                $("#new-message-area").focus();
            }
            else {
                //alert(senderID + ' / '+receiverID+ ' / '+ subject+ ' / '+message+ ' / '+messageType );
                sendMessage(true, senderID, receiverID, subject, message, messageType);
            }
        }
    });


});

$(document).on('pagehide' , '#inbox-page' , function(){
    $("#log-out-btn").unbind('click');
    $("#get-more-msg").unbind('click');
});

$(document).on('pagehide' , '#new-message-page' , function(){
    recipientID = null;
    recipientName = null;
    $("#recipient_name_field").val('');
    $("#subject_field").val('');
    $("#new-message-area").val('');
    $("#send-new-msg-btn").unbind('click');
    


});

$(document).on('pageshow' , '#select-recipient-page' , function(){
    populateRecipientList();


});

$(document).on('pageshow' , '#select-teacher-page' , function(){
    $("#select-teacher-header-text").text(selectTeacherHeaderText);
    populateStudentsTeachersList(studentID);


});


$(document).on('pageshow' , '#inbox-page' , function(){
    messageListPage = 'inbox';
    getInboxMessageList();
   // getSentMessageList();
    
    recipientList.length = 0;
    
    
    if(localStorage.getItem('recipients') === null){
        getRecipientList();
    }
    else{
        //retrieve cached recipients from localstorage
        recipientList = JSON.parse(localStorage["recipients"]);
    }
    
    $("#get-more-msg").click( function(){
        getOlderInboxMessageList();
    });


    $("#log-out-btn").click( function(){
        
        $("#login-btn").removeAttr("disabled");
        
        $.mobile.changePage( "#logout-page", {
            transition: "slidedown",
            reverse: false,
            changeHash: true
        });
        logout();

    });
    

});

$(document).on('pageshow' , '#sentbox-page' , function(){
    messageListPage = 'sent';
    populateSentMessageList();
});

$(document).on('pageshow' , '#message-page' , function(){
    
    if(messageListPage == 'inbox'){
        //getInboxMessage(messageID);
        getCachedInboxMessage(messageIndex);
    }
    else if(messageListPage == 'sent'){
        getSentMessage(messageID) ;
    }
    
});

$(document).on('pagehide' , '#message-page' , function(){
    messageID = null;
    messageIndex = null;
    recipientID = null;
    replyThreadID = null;
    messageListPage = '';
    $("#reply-message-area").val('');
    $("#reply-message-btn").unbind('click');
   // $("#message-page-header").text('');
    $("#message-page .iscroll-content").html('');
    
    failedMessages.length = 0; //Clear out temporarily saved failed messages
});

function getUnreadMessages(){
    userID = localStorage.getItem('userID');
    schoolId = localStorage.getItem('schoolId');
   // alert(userID);
    $.ajax({
        url: SERVICE_URL,
        type: "POST",
        data: {action: 'getUnreadMessages', user_id: userID , schoolId:schoolId},
        crossDomain: true,
        
        success: function(data) {
            
//            alert('success');
           // alert(data);
//            return data;
            if(data > 0){
                $("#unread-msg-count").text(data);
            }
        },
        error: function() {
            //alert('error');
        }
    });
    
}

function getRecipientList(){
    parentID = localStorage.getItem('parentID');
    schoolId = localStorage.getItem('schoolId');
    
    recipientList.length = 0;
    
    $.ajax({
        url: SERVICE_URL,
        type: "POST",
        data: {action: 'getRecipientList', id: parentID , schoolId:schoolId},
        dataType: 'json',
        crossDomain: true,
        
        success: function(json) {
            if (json.recipient != null) {

                //alert("rc not null");



                if (json.recipient.length > 0) {

                    //alert("greater than zer0");

                    $.each(json.recipient, function() {
                        //alert(this['role']);
                        recipient = {
                            fullname: this['fullname'],
                            userID: this['user_id'],
                            recipientID: this['recipient_id'],
                            recipientType: this['recipient_type'],
                            studentName: this['studentName'],
                            role: this['role'],
                            roleType: this['roleType'],
                            studentId : this['studentId'],
                            noOfWards : this['noOfWards']

                        };
                        
                            recipientList.push(recipient);

                       

                    });

                    //Cache Recipients in localStorage
                    localStorage["recipients"] = JSON.stringify(recipientList);

                }

            }
            else {
                 //alert('user is null');
            }

        },
        error: function() {
           // alert('error');
        }
    });
}

function populateRecipientList(){
    
    if(recipientList.length > 0){
        var recipList ='';
        if(recipientList[0].noOfWards < 2){
            for(var i = 0; i < recipientList.length ; i++){
                recipient = recipientList[i];

                if(recipient.recipientType == 0){
                   recipList = recipList + '<li><a id="' + recipient.userID + '" href="#new-message-page"  data-transition="slide" \n\
            class ="getRecipientID"><img src="css/icons/user-icon.png" class="ui-li-icon ui-corner-none"><span>Admin : '+ '<br><span style="font-size:12px; font-weight:normal;">' + recipient.fullname +'</span> </span> </a></li>'; 
                }

                else if(recipient.recipientType == 1){

                    if(recipient.roleType === 'c'){
                     recipList = recipList + '<li><a id="' + recipient.userID + '" href="#new-message-page"  data-transition="slide" \n\
            class ="getRecipientID"><img src="css/icons/user-icon.png" class="ui-li-icon ui-corner-none"><span>' + recipient.studentName + '\'s Class Teacher : <br>' +
                '<span style="font-size:12px; font-weight:normal;">' 
                    + recipient.fullname + ' </span></span> </a></li>';
                    }

                    if(recipient.roleType === 's'){
                     recipList = recipList + '<li><a id="' + recipient.userID + '" href="#new-message-page"  data-transition="slide" \n\
            class ="getRecipientID"><img src="css/icons/user-icon.png" class="ui-li-icon ui-corner-none"><span>' + recipient.studentName + '\'s ' + recipient.role + ' Teacher : <br>' +
                '<span style="font-size:12px; font-weight:normal;">' 
                    + recipient.fullname + ' </span></span> </a></li>';
                    }
                }


            }
    }else{
            studentIds = new Array;
            count = 0;
            for(var i = 0; i < recipientList.length ; i++){
                recipient = recipientList[i];

                if(recipient.recipientType == 0){
                   recipList = recipList + '<li><a id="' + recipient.userID + '" href="#new-message-page"  data-transition="slide" \n\
            class ="getRecipientID"><img src="css/icons/user-icon.png" class="ui-li-icon ui-corner-none"><span>Admin : '+ '<br><span style="font-size:12px; font-weight:normal;">' + recipient.fullname +'</span> </span> </a></li>'; 
                }

                else if(recipient.recipientType == 1){
                    if(count == 0){
                        studentIds.push(recipient.studentId);
                        count++;
                        recipList = recipList + '<li><a id="' + recipient.studentId + '" href="#select-teacher-page"  data-transition="slide" \n\
                            class ="getStudentID"><img src="css/icons/user-icon.png" class="ui-li-icon ui-corner-none"><span>' + recipient.studentName + '\'s Teachers';
                    }
                    else{
                        if(inArray(recipient.studentId , studentIds)){
                            continue;
                        }
                        else{
                            studentIds.push(recipient.studentId);
                            count++;
                            recipList = recipList + '<li><a id="' + recipient.studentId + '" href="#select-teacher-page"  data-transition="slide" \n\
                                class ="getStudentID"><img src="css/icons/user-icon.png" class="ui-li-icon ui-corner-none"><span>' + recipient.studentName + '\'s Teachers';
                        }
                    }
                }


            }
        
    }
    //$("#recipient-list").empty();
    $("#recipient-list").html(recipList);
    $("#recipient-list").listview("refresh");
      
    $(".getRecipientID").click( function(){
        
        recipientID = $(this).attr('id');
        recipientName = $(this).text();
    });
    
    $(".getStudentID").click( function(){
        
        studentID = $(this).attr('id');
        selectTeacherHeaderText = $(this).text();

    });

       // alert('has recips');
    }
    
    else{
       // alert('no recps');
    }
}

function populateStudentsTeachersList(studentID){
    recipList ='';
    for(var i = 0; i < recipientList.length ; i++){
        recipient = recipientList[i];
        
        if(recipient.recipientType == 1 && recipient.studentId == studentID){

               if(recipient.roleType === 'c'){
                recipList = recipList + '<li><a id="' + recipient.userID + '" href="#new-message-page"  data-transition="slide" \n\
       class ="getRecipientID"><img src="css/icons/user-icon.png" class="ui-li-icon ui-corner-none"><span> Class Teacher : <br>' +
           '<span style="font-size:12px; font-weight:normal;">' 
               + recipient.fullname + ' </span></span> </a></li>';
               }

               if(recipient.roleType === 's'){
                recipList = recipList + '<li><a id="' + recipient.userID + '" href="#new-message-page"  data-transition="slide" \n\
       class ="getRecipientID"><img src="css/icons/user-icon.png" class="ui-li-icon ui-corner-none"><span>'  + recipient.role + ' Teacher : <br>' +
           '<span style="font-size:12px; font-weight:normal;">' 
               + recipient.fullname + ' </span></span> </a></li>';
               }
           }   
        
    }
    
    $("#teachers-list").html(recipList);
    $("#teachers-list").listview("refresh");
      
    $(".getRecipientID").click( function(){
        
        recipientID = $(this).attr('id');
        recipientName = $(this).text();
    });
}

function inArray(param , array){
    for( i = 0 ; i < array.length; i++){
        if(array[i] == param){
          //  alert('in array');
            return true;
        }
    }
    //alert('not in array');
    return false;
    
}

function sendMessage(returnToHomePageOnMessageSent, senderID, receiverID, subject, message, messageType, threadID, senderName , msgDate, wrapperId){
    schoolId = localStorage.getItem('schoolId');
    
    errorHTML = '<span id="resend-msg-'+ wrapperId +'" class="resend-msg" style="padding-right:10px;"><img src="images/retry.png"/></span>' +
    '<span id="delete-msg-'+wrapperId+'" class="delete-msg"><img src="images/delete.png"/></span>';
    
    //create temp message object for caching incase of failure

    messageObject = {
        senderID : senderID,
        receiverID : receiverID,
        subject: subject,
        message : message,
        messageType: messageType,
        threadID: threadID,
        senderName: senderName,
        msgDate: msgDate,
        wrapperId: wrapperId
    };
    

    
    $("#loader").show();
    $.ajax({
        type: "POST",
        url: SERVICE_URL,
        data: {action: "sendMessage", senderID: senderID, receiverID: receiverID,
            subject: subject, message: message, messageType: messageType, threadID:threadID , schoolId:schoolId},
        dataType: "json",
        crossDomain: true,
        success: function(json) {
            $("#loader").hide();
            if (json.data["status"] == 'success') {
               // alert(json.data["message"]);
                //closeMessageModal();
                
                if(msgDate !== 'undefined'){
                  
                    $("#msg-sending-" + wrapperId).html(msgDate);
                   // $("#msg-sending").removeAttr("id");

                }
                $().toastmessage('showSuccessToast', "Message Sent!");
                
                if(returnToHomePageOnMessageSent){
                    $.mobile.changePage( "#inbox-page", {
                        transition: "slidedown",
                        reverse: false,
                        changeHash: true
                    });
                }

            }
            else {
               // alert(json.data["message"]);
                if(msgDate !== 'undefined'){
                    $("#msg-sending-" + wrapperId).html(errorHTML);
                    failedMessages.push(messageObject);
                   // $("#msg-sending").removeAttr("id");
                }
                $().toastmessage('showErrorToast', json.data["message"]);
            }


        },
        error: function() {
            $("#loader").hide();
           // alert("Unable to connect to the server");
            if(msgDate !== 'undefined'){
                $("#msg-sending-" + wrapperId).html(errorHTML);
                failedMessages.push(messageObject);
                //$("#msg-sending").removeAttr("id");
            }
            $().toastmessage('showErrorToast', "Unable To Connect To Server");

        },
        complete: function(){
     
        }

    });
    
}

$(document).on('click', '.delete-msg', function(){
    id = $(this).attr('id');
    split = id.split('-');
    wrapperId = split[2];
    
    $("#message-wrapper-" + wrapperId).remove();
});

$(document).on('click', '.resend-msg', function(){

    id = $(this).attr('id');
    split = id.split('-');
    wrapperId = split[2];
    
    for(i = 0; i < failedMessages.length; i++){
        messageObject = failedMessages[i];
        
        if(messageObject.wrapperId == wrapperId){

            failedMessages.splice(i , 1); //remove message object from array
            $("#msg-sending-" + wrapperId).html('<span style="color: #4DEC0F; font-size: 12px;"><img src="images/sending-loader.gif" class="footer-loader" /> sending...</span>');
            sendMessage(false, messageObject.senderID, messageObject.receiverID, messageObject.subject,
                messageObject.message, messageObject.messageType, messageObject.threadID, messageObject.senderName,
                messageObject.msgDate, messageObject.wrapperId);
        }
    }
    

});


function getInboxMessageList(){
    $("#get-more-msg-wrapper").hide();
    userID = localStorage.getItem('userID');
    schoolId = localStorage.getItem('schoolId');
    messagesCount = inboxList.length; //Get How Many Messages are cached

    inboxList.length = 0; //Empty the Inbox Message List Array
    
    isFetchingMessage = true;
   // $("#message-loader").show();
    
    $("#retrieve-mail-status").css('color' , '#666');
    $("#retrieve-mail-status").css('cursor' , 'default');    
    
    $("#retrieve-mail-status").html('Checking for new messages... <span><img src="images/footer-loader.gif" class="footer-loader" /></span>');
   // alert('started fetching messages');
    $.ajax({
        url: SERVICE_URL,
        type: "POST",
        data: {action: 'getInboxMessageList', userID: userID , schoolId:schoolId, start:0, limit:messagesCount},
        dataType: 'json',
        crossDomain: true,
        
        success: function(json) {
            if (json.inboxList != null) {

                if (json.inboxList.length > 0) {

                    $.each(json.inboxList, function() {

                        inboxItem = {
                            id: this['msg_id'],
                            status: this['msg_status'],
                            date: this['msg_date'],
                            subject: this['msg_title'],
                            sender: this['senderName'],
                            messages: this['message'],
                            senderID: this['senderID'],
                            senderName: this['senderName'],
                            senderRole: this['senderRole'],
                            receiverName: this['receiverName'],
                            receiverRole: this['receiverRole'],
                            messageDate: this['date'],
                            threadID: this['threadID'],
                            messageType: this['messageType'],
                            senderPhoto : this['senderPhoto']
                            

                        };

                            inboxList.push(inboxItem);
  
                            cachedInboxList.push(inboxItem);


                    });
                   //Cache Messages in localStorage
                    localStorage["inbox"] = JSON.stringify(cachedInboxList);
                    
                    
                }

            }
            else {
                //alert('inbox is null');
            }
            
            isFetchingMessage = false;
            
            $("#retrieve-mail-status").html('Updated!');
            $("#retrieve-mail-status").removeClass('retry');

        },
        error: function() {
           // alert('error');
            isFetchingMessage = false;
            $("#message-loader").hide();
            $("#retrieve-mail-status").html('Couldn\'t fetch mail! Tap to retry.');
            $("#retrieve-mail-status").css('color' , 'red');
            $("#retrieve-mail-status").css('cursor' , 'pointer');
            $("#retrieve-mail-status").addClass('retry');
            
            $('.retry').click(function(){
                getInboxMessageList();
            });
            
            
           //If messages cant be retrieved from the server
           //retrieve cached messages from localstorage
           if(localStorage["inbox"] != undefined){
                inboxList = JSON.parse(localStorage["inbox"]);
           }

        },
        complete: function(){
            populateInboxMessageList();
        }
    });
}


function getOlderInboxMessageList(){

    userID = localStorage.getItem('userID');
    schoolId = localStorage.getItem('schoolId');
    messagesCount = inboxList.length + 1; //Get How Many Messages are cached
 
    
    $("#get-more-msg").html('<span><img src="images/footer-loader.gif" class="footer-loader" /></span>');

    $.ajax({
        url: SERVICE_URL,
        type: "POST",
        data: {action: 'getInboxMessageList', userID: userID , schoolId:schoolId , start:messagesCount},
        dataType: 'json',
        crossDomain: true,
        
        success: function(json) {
           // alert('success');
            if (json.inboxList != null) {

               // alert("inbox not null");



                if (json.inboxList.length > 0) {

                    $.each(json.inboxList, function() {

                        inboxItem = {
                            id: this['msg_id'],
                            status: this['msg_status'],
                            date: this['msg_date'],
                            subject: this['msg_title'],
                            sender: this['senderName'],
                            messages: this['message'],
                            senderID: this['senderID'],
                            senderName: this['senderName'],
                            senderRole: this['senderRole'],
                            receiverName: this['receiverName'],
                            receiverRole: this['receiverRole'],
                            messageDate: this['date'],
                            threadID: this['threadID'],
                            messageType: this['messageType'],
                            senderPhoto : this['senderPhoto']
                            

                        };
    
                            inboxList.push(inboxItem);

                            cachedInboxList.push(inboxItem);


                    });

                    localStorage["inbox"] += JSON.stringify(cachedInboxList);
                    
                    
                }

            }
            else {
                //alert('inbox is null');
            }
            

            


        },
        error: function() {
            $().toastmessage('showErrorToast', "Unable to retrieve older messages at this time. Please try again.");

           if(localStorage["inbox"] != undefined){
                inboxList = JSON.parse(localStorage["inbox"]);
            }

        },
        complete: function(){
            $("#get-more-msg").html('Older Messages');
            populateInboxMessageList();
        }
    });
}

function populateInboxMessageList(){

    if(inboxList.length > 0){
        $("#get-more-msg-wrapper").show();
        $("#no-message-container").html('');
        msgList ='';
        for(var i = 0; i < inboxList.length ; i++){
            msg = inboxList[i];
            
            msgID = msg.id + '_' + i;
            if(msg.status == 'U'){
               msgList = msgList + '<li class="unread"><a id="' + msgID + '" href="#message-page"  data-transition="slide" \n\
        class ="getMessageID"><h2 class="sender-name">' + msg.subject + '</h2><p class="message-title">'+ msg.sender + '</p>\n\
         <p class="ui-li-aside message-date"><strong>' + msg.date + '</strong></p></a></li>'; 
            }
            else if(msg.status == 'R'){
                msgList = msgList + '<li class="read"><a id="' + msgID + '" href="#message-page"  data-transition="slide" \n\
        class ="getMessageID"><h2 class="sender-name">' + msg.subject + '</h2><p class="message-title">'+ msg.sender + '</p>\n\
         <p class="ui-li-aside message-date"><strong>' + msg.date + '</strong></p></a></li>'; 
            }
            
            
        }

    $("#inbox-list").html(msgList);
    $("#inbox-list").listview("refresh");

    $("#inbox-page-content .iscroll-wrapper").iscrollview("refresh");

      
    $(".getMessageID").click( function(){
        
        id = $(this).attr('id').split('_');
        messageID = id[0];
        messageIndex = id[1];
        
        msgObj = inboxList[messageIndex];
        //Mark Message as Read.
        msgObj.status = 'R';

        readMessage(messageID);
    });

     
    }
    
    else{
       // No Inbox Messages
       $("#no-message-container").html('No Messages!');
       $("#get-more-msg-wrapper").hide();
    }
}




function getCachedInboxMessage(messageIndex) {

    msgObj = inboxList[messageIndex];
    
    userID = localStorage.getItem('userID');
    messages = msgObj.messages;
    senderID = msgObj.senderID;
    senderName = msgObj.senderName;
    receiverName = msgObj.receiverName;
    messageDate = msgObj.messageDate;
    
    senderRole = msgObj.senderRole;
    senderPhoto = msgObj.senderPhoto;
 
    output = '';
    
    //alert('sender Photo : ' + senderPhoto);
    
//    if(senderPhoto === ''){
//       // $("#sender-image").attr('src' , 'images/user.JPG');
//    }
//    else{
//       // $("#sender-image").attr('src' , senderPhoto);
//    }
    userPhoto = 'images/default.jpg';
    recipientPhoto = senderPhoto;

    
   

    if (messages instanceof Array) {
        var count = 0;
        for (var i = 0; i < messages.length; i++) {
            msg = messages[i].content;
            //msgDate = messages[i].date;
            msgDate = moment(messages[i].date).format('DD MMM YYYY : HH :mm');
            count++;
            if (messages[i].sender_id === userID) {
                //This is the current user's message



                output += '<div class="message-wrapper" id="message-wrapper-' + count  +'">' +
                            '<div class="message-block">' +
                            '<div class="message-image-block">'+
                            ' <img src ="'+userPhoto+'" alt="" class="msg-img" width="40" height="40">'+
                            '</div>'+
                            '<div class="message-content-block">'+
                                '<div class="msg-name"> Me</div>'+
                                '<div class="msg-body">' +
                                    msg +
                                '</div>'+
                                '<div class="msg-date">'+
                                    msgDate+
                                '</div>'+
                            '</div>'+
                        '<div style="clear: both"></div>' +
                        '</div></div>';


            }
            else {
                //This is the other user's message

               output += '<div class="message-wrapper" id="message-wrapper-' + count  +'">' +
                        '<div class="message-block other-user-message-block">' +
                        '<div class="message-content-block">'+
                            '<div class="msg-name">'+ senderName  +'</div>'+
                            '<div class="msg-body">' +
                                msg +
                            '</div>'+
                            '<div class="msg-date">'+
                                msgDate+
                            '</div>'+
                            '</div>'+
                            '<div class="message-image-block">'+
                            ' <img src ="'+recipientPhoto+'" alt="" class="msg-img" width="40" height="40">'+
                            '</div>'+
                            '<div style="clear: both"></div>' +
                        '</div></div>';
            }
            
        }
    }
    else {
        //This is a notification
               output += '<div class="message-wrapper">' +
                        '<div class="message-block other-user-message-block">' +
                        '<div class="message-content-block">'+
                            '<div class="msg-name">'+ senderName  +'</div>'+
                            '<div class="msg-body">' +
                                messages +
                            '</div>'+
                            '<div class="msg-date">'+
                                messageDate+
                            '</div>'+
                            '</div>'+
                            '<div class="message-image-block">'+
                            ' <img src ="'+recipientPhoto+'" alt="" class="msg-img" width="40" height="40">'+
                            '</div>'+
                            '<div style="clear: both"></div>' +
                        '</div></div>';

    }


    $("#sender-name").text(senderName);
    $("#sender-capacity").text(senderRole);
    
    $("#message-subject").text(msgObj.subject);

    $("#message-page .iscroll-content").html(output);
    $("#message-page  .iscroll-wrapper").iscrollview("refresh");


    if (msgObj.messageType == 1) {
        //alert('notuf');
        $("#message-page-footer").hide();
    }
    else {
        //alert('message');
        $("#message-page-footer").show();
    }

    recipientID = senderID;
    replyThreadID = msgObj.threadID;

    $("#reply-message-btn").click( function(){
        //alert(recipientID);
        if(recipientID != null){
            messageType = 0; //Defaults to Message
            senderID = localStorage.getItem('userID');
            receiverID = recipientID;
            subject = 'RE: ' +  $.trim($("#message-subject").text());
            message = $.trim($("#reply-message-area").val());
            msgDate = moment(new Date()).format('DD MMM YYYY : HH :mm');
            if(message == ''){
                $("#reply-message-area").focus();
            }
            else{
                 count++;
                 output = '<div class="message-wrapper" id="message-wrapper-' + count  +'">' +
                                    '<div class="message-block">' +
                                        '<div class="message-image-block">'+
                                        ' <img src ="'+userPhoto+'" alt="" class="msg-img" width="40" height="40">'+
                                        '</div>'+
                                        '<div class="message-content-block">'+
                                            '<div class="msg-name">Me</div>'+
                                            '<div class="msg-body">' +
                                                message +
                                            '</div>'+
                                            '<div class="msg-date" id="msg-sending-'+ count +'">'+
                                                '<span style="color: #4DEC0F; font-size: 12px;"><img src="images/sending-loader.gif" class="footer-loader" /> sending...</span>'+
                                            '</div>'+
                                        '</div>' +
                                        '<div style="clear: both"></div>' +
                                    '</div></div>';
                            
                $("#reply-message-area").val('');
                $("#message-page .iscroll-content").append(output);
                $("#reply-message-area").focusout();
                sendMessage(false, senderID, receiverID, subject, message, messageType, replyThreadID, senderName , msgDate , count);    

            }
            

        
        }
        else{
            //alert('Recipient ID is null');
        }

    });


}



function getSentMessageList(){
    userID = localStorage.getItem('userID');
    schoolId = localStorage.getItem('schoolId');
    sentBoxList.length = 0; //Empty the Sent Message List Array
    $.ajax({
        url: SERVICE_URL,
        type: "POST",
        data: {action: 'getSentMessagesList', userID: userID , schoolId:schoolId},
        dataType: 'json',
        crossDomain: true,
        
        success: function(json) {
            if (json.sentMessagesList != null) {

                //alert("sent not null");



                if (json.sentMessagesList.length > 0) {

                   // alert("greater than zer0");
                    
                    $.each(json.sentMessagesList, function() {
                       // alert(this['msg_title']);
                        sentBoxItem = {
                            id: this['msg_id'],
                            date: this['msg_date'],
                            subject: this['msg_title'],
                            receiver: this['receiverName']

                        };
                        
                            sentBoxList.push(sentBoxItem);
                       

                    });
                    
                }
                else{
                   // alert('less than zero');
                }

            }
            else {
               // alert('sent is null');
            }

        },
        error: function() {
           // alert('error');
        }
    });
}

function populateSentMessageList(){
    
    if(sentBoxList.length > 0){
       
        $("#no-sent-message-container").html('');
        msgList ='';
        for(var i = 0; i < sentBoxList.length ; i++){
            msg = sentBoxList[i];
            
            msgList = msgList + '<li class="read"><a id="' + msg.id + '" href="#message-page"  data-transition="slide" \n\
        class ="getMessageID"><h2 class="sender-name">' + msg.receiver + '</h2><p class="message-title">'+ msg.subject + '</p>\n\
         <p class="ui-li-aside message-date"><strong>' + msg.date + '</strong></p></a></li>'; 
            
            
            
        }

    $("#sent-list").html(msgList);
    $("#sent-list").listview("refresh");
      
    $(".getMessageID").click( function(){
        
        messageID = $(this).attr('id');

    });

     
    }
    
    else{
       
       // No Sent Messages
       $("#no-sent-message-container").html('No Sent Messages!');
    }
}

function getSentMessage(messageID) {
    schoolId = localStorage.getItem('schoolId');
    //Hide the footer that contains the Reply Textarea
    $("#message-page-footer").hide();
    $.ajax({
        type: "POST",
        url: SERVICE_URL,
        data: {action: "getSentMessage", messageID: messageID, schoolId:schoolId},
        timeout: 60000, //One Minute
        dataType: "json",
        success: function(json) {
            
            
            message = json.data["message"];
            senderID = json.data["senderID"];
            senderName = json.data["senderName"];
            receiverName = json.data["receiverName"];
            messageDate = json.data["date"];
           // alert(messageDate);
           // msgDate = moment(messageDate).format('DD MMM YYYY : HH :mm');
            output = '';

            output += '<div class="message-wrapper">' +
                        '<div class="message-block">' +
                            '<div class="msg-name">Me</div>'+
                            '<div class="msg-body">' +
                                message +
                            '</div>'+
                            '<div class="msg-date">'+
                                messageDate+
                            '</div>'+
                        '</div>';


            $("#message-page-header").text(json.data["subject"]);
            $("#message-page-content").html(output);
            

            

        },
        complete: function(json) {

        },
        error: function(x, t, m) {

            if (t === "timeout") {
                navigator.notification.alert("Unable to Retrieve Mail at this time. Please try again.", function() {
                    }, 'Connection Error', 'Dismiss');
            } else {
                navigator.notification.alert("Unable to connect to the server.\nConnect to the Internet and try again.", function() {
                    }, 'Connection Error', 'Dismiss');
            }

        }

    });

}


function readMessage(messageID){
    schoolId = localStorage.getItem('schoolId');
    $.ajax({
        url: SERVICE_URL,
        type: "POST",
        data: {action: 'readMessage', messageID: messageID, schoolId:schoolId},
        crossDomain: true,
        
        success: function(data) {
            if(data == 1){
               // alert('message read');
            }
            else{
               // alert('error reading message');
            }
            
        },
        error: function() {
           // alert('error');
        }
    });    
}


function getSchoolsList(){
    $("#ajax-loader-div").show();
    $("#connecting").css('color' , '#FFF');
    $("#connecting").css('margin-top' , '0px');
    $("#connecting").text('Fetching list of schools...');
    
    //$('#select_school').html('<option value ="select">-- Select School--</option>');
    
   // schoolsOption ='<option value ="select">-- Select School--</option>';
    
    
    $('.retry-schools-list').unbind('click');
    
    //$('#select_school').html(schoolsOption);
    $.ajax({
        url: SCHOOLS_URL,
        type: "POST",
        dataType: "json",
        crossDomain: true,
        
        success: function(data) {
            //alert('success');
            schoolsOption ='<option value ="select">-- Select School--</option>';
            $.each(data, function() {
                schoolID = (this['id']);
                schoolName = (this['name']);

                schoolsOption += '<option value="'+ schoolID + '" >' + schoolName + '</option>';
            });
            
            $('#select_school').html(schoolsOption);
            $("#connecting").text('');
        },
        error: function() {
           // alert('Unable to get list of schools.\nPlease check your internet connection.');
            $("#connecting").text('Unable to get list of schools. Tap Here to retry!');
            $("#connecting").css('color' , 'red');
            $("#connecting").css('font-size' , '14px');
            $("#connecting").css('margin-top' , '10px');
            $("#connecting").css('cursor' , 'pointer');
            $("#connecting").addClass('retry-schools-list');
            
            $('.retry-schools-list').click(function(){
                getSchoolsList();
            });
        },
        complete: function (){
            $("#ajax-loader-div").hide();
            
        }
        
    }); 
}


function goHome(){
	//destroyBackButton();
	
	document.addEventListener("backbutton", function(e) {
        navigator.app.exitApp();
    }, false);
}

function goBack(){
	//destroyBackButton();
	
	document.addEventListener("backbutton", function(e) {
        navigator.app.backhistory();
    }, false);
}

function destroyBackButton(){
	//Unregister the back button event
	document.removeEventListener('backbutton');
}


function logout(){
    userID = localStorage.getItem('userID');
    regID = localStorage.getItem('regID');
    
    $.ajax({
        url: SERVICE_URL,
        dataType: "json",
        data: {action: "logout" , user_id: userID, reg: regID},
        crossDomain: true,
        
        success: function() {
           
        },
        error: function() {
           
        },
        complete: function(){
            localStorage.clear(); //Clear Out The LocalStorage
            recipientList.length = 0; //Clear Out The Recipient List
            cachedRecipientList.length = 0; //Clear Out The Cached Recipient List
            inboxList.length = 0; //Clear Out The Inbox List
            cachedInboxList.length = 0; //Clear Out The Cache Inbox List

            $.mobile.changePage( "#login-page", {
                transition: "slideup",
                reverse: false,
                changeHash: true
            });
        }
    });  
}

function inboxPagePullDown(){
    getInboxMessageList();
    getRecipientList();   
}





